---
description: Install Vector on your OS or platform
---

# Installation

Vector compiles to a single static binary, making it simple to install.

## Installer Script

Run the following in your terminal, then follow the on-screen
instructions:

```bash
curl https://sh.vector.dev -sSf | sh
```

This script performs platform detection and helps you choose the best
method for installation. If you prefer a manual approach, choose your
specific platform below.

## Platforms

{% page-ref page="platforms/docker.md" %}

## Package Managers

{% page-ref page="package-managers/apt.md" %}

{% page-ref page="package-managers/homebrew.md" %}

{% page-ref page="package-managers/yum.md" %}

## Operating Systems

{% page-ref page="operating-systems/amazon-linux.md" %}

{% page-ref page="operating-systems/centos.md" %}

{% page-ref page="operating-systems/debian.md" %}

{% page-ref page="operating-systems/macos.md" %}

{% page-ref page="operating-systems/rhel.md" %}

{% page-ref page="operating-systems/ubuntu.md" %}

## Manual

{% page-ref page="manual/from-archives.md" %}

{% page-ref page="manual/from-source.md" %}



